import { Subject } from 'rxjs';
import { filter, take } from 'rxjs/operators';
import { Injectable, ApplicationRef, NgZone, NgModule, defineInjectable, inject } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxBootstrapModalService {
    /**
     * @param {?} _appRef
     * @param {?} _zone
     */
    constructor(_appRef, _zone) {
        this._appRef = _appRef;
        this._zone = _zone;
    }
    /**
     * @return {?}
     */
    get appRef() {
        return this._appRef;
    }
    /**
     * @return {?}
     */
    get zone() {
        return this._zone;
    }
    /**
     * @param {?} templateRef
     * @return {?}
     */
    show(templateRef) {
        /** @type {?} */
        const events$ = new Subject();
        /** @type {?} */
        const instance = {
            shown: new Promise((/**
             * @param {?} resolve
             * @return {?}
             */
            resolve => {
                events$
                    .pipe(filter((/**
                 * @param {?} e
                 * @return {?}
                 */
                e => 'shown' === e.type)))
                    .pipe(take(1))
                    .subscribe((/**
                 * @return {?}
                 */
                () => {
                    this.zone.run(resolve);
                }));
            })),
            hidden: new Promise((/**
             * @param {?} resolve
             * @return {?}
             */
            resolve => {
                events$
                    .pipe(filter((/**
                 * @param {?} e
                 * @return {?}
                 */
                e => 'hidden' === e.type)))
                    .pipe(take(1))
                    .subscribe((/**
                 * @return {?}
                 */
                () => resolve()));
            })),
            events: events$.asObservable(),
            hide: null,
            handleUpdate: null,
            modalEl: null
        };
        /** @type {?} */
        const viewRef = templateRef.createEmbeddedView({ instance });
        this.appRef.attachView(viewRef);
        /** @type {?} */
        const el = instance.modalEl = viewRef.rootNodes[0];
        document.body.appendChild(el);
        /** @type {?} */
        const $el = jQuery(el);
        $el.modal({ show: false });
        $el.on('show.bs.modal shown.bs.modal hide.bs.modal hidden.bs.modal', (/**
         * @param {?} event
         * @return {?}
         */
        (event) => {
            this.zone.run((/**
             * @return {?}
             */
            () => {
                events$.next(event);
            }));
        }));
        instance.hide = (/**
         * @return {?}
         */
        () => {
            $el.modal('hide');
            return instance.hidden;
        });
        instance.handleUpdate = (/**
         * @return {?}
         */
        () => {
            $el.modal('handleUpdate');
        });
        instance.hidden.then((/**
         * @return {?}
         */
        () => {
            $el.off('show.bs.modal shown.bs.modal hide.bs.modal hidden.bs.modal');
            $el.modal('dispose');
            document.body.removeChild(el);
            this.appRef.detachView(viewRef);
            viewRef.destroy();
        }));
        $el.modal('show');
        return instance;
    }
}
NgxBootstrapModalService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgxBootstrapModalService.ctorParameters = () => [
    { type: ApplicationRef },
    { type: NgZone }
];
/** @nocollapse */ NgxBootstrapModalService.ngInjectableDef = defineInjectable({ factory: function NgxBootstrapModalService_Factory() { return new NgxBootstrapModalService(inject(ApplicationRef), inject(NgZone)); }, token: NgxBootstrapModalService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxBootstrapModalModule {
}
NgxBootstrapModalModule.decorators = [
    { type: NgModule, args: [{
                providers: [NgxBootstrapModalService]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxBootstrapModalService, NgxBootstrapModalModule };

//# sourceMappingURL=nowzoo-ngx-bootstrap-modal.js.map