import { Subject } from 'rxjs';
import { filter, take } from 'rxjs/operators';
import { Injectable, ApplicationRef, NgZone, NgModule, defineInjectable, inject } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBootstrapModalService = /** @class */ (function () {
    function NgxBootstrapModalService(_appRef, _zone) {
        this._appRef = _appRef;
        this._zone = _zone;
    }
    Object.defineProperty(NgxBootstrapModalService.prototype, "appRef", {
        get: /**
         * @return {?}
         */
        function () {
            return this._appRef;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NgxBootstrapModalService.prototype, "zone", {
        get: /**
         * @return {?}
         */
        function () {
            return this._zone;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} templateRef
     * @return {?}
     */
    NgxBootstrapModalService.prototype.show = /**
     * @param {?} templateRef
     * @return {?}
     */
    function (templateRef) {
        var _this = this;
        /** @type {?} */
        var events$ = new Subject();
        /** @type {?} */
        var instance = {
            shown: new Promise((/**
             * @param {?} resolve
             * @return {?}
             */
            function (resolve) {
                events$
                    .pipe(filter((/**
                 * @param {?} e
                 * @return {?}
                 */
                function (e) { return 'shown' === e.type; })))
                    .pipe(take(1))
                    .subscribe((/**
                 * @return {?}
                 */
                function () {
                    _this.zone.run(resolve);
                }));
            })),
            hidden: new Promise((/**
             * @param {?} resolve
             * @return {?}
             */
            function (resolve) {
                events$
                    .pipe(filter((/**
                 * @param {?} e
                 * @return {?}
                 */
                function (e) { return 'hidden' === e.type; })))
                    .pipe(take(1))
                    .subscribe((/**
                 * @return {?}
                 */
                function () { return resolve(); }));
            })),
            events: events$.asObservable(),
            hide: null,
            handleUpdate: null,
            modalEl: null
        };
        /** @type {?} */
        var viewRef = templateRef.createEmbeddedView({ instance: instance });
        this.appRef.attachView(viewRef);
        /** @type {?} */
        var el = instance.modalEl = viewRef.rootNodes[0];
        document.body.appendChild(el);
        /** @type {?} */
        var $el = jQuery(el);
        $el.modal({ show: false });
        $el.on('show.bs.modal shown.bs.modal hide.bs.modal hidden.bs.modal', (/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            _this.zone.run((/**
             * @return {?}
             */
            function () {
                events$.next(event);
            }));
        }));
        instance.hide = (/**
         * @return {?}
         */
        function () {
            $el.modal('hide');
            return instance.hidden;
        });
        instance.handleUpdate = (/**
         * @return {?}
         */
        function () {
            $el.modal('handleUpdate');
        });
        instance.hidden.then((/**
         * @return {?}
         */
        function () {
            $el.off('show.bs.modal shown.bs.modal hide.bs.modal hidden.bs.modal');
            $el.modal('dispose');
            document.body.removeChild(el);
            _this.appRef.detachView(viewRef);
            viewRef.destroy();
        }));
        $el.modal('show');
        return instance;
    };
    NgxBootstrapModalService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgxBootstrapModalService.ctorParameters = function () { return [
        { type: ApplicationRef },
        { type: NgZone }
    ]; };
    /** @nocollapse */ NgxBootstrapModalService.ngInjectableDef = defineInjectable({ factory: function NgxBootstrapModalService_Factory() { return new NgxBootstrapModalService(inject(ApplicationRef), inject(NgZone)); }, token: NgxBootstrapModalService, providedIn: "root" });
    return NgxBootstrapModalService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBootstrapModalModule = /** @class */ (function () {
    function NgxBootstrapModalModule() {
    }
    NgxBootstrapModalModule.decorators = [
        { type: NgModule, args: [{
                    providers: [NgxBootstrapModalService]
                },] }
    ];
    return NgxBootstrapModalModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxBootstrapModalService, NgxBootstrapModalModule };

//# sourceMappingURL=nowzoo-ngx-bootstrap-modal.js.map